<!DOCTYPE HTML>
<html lang="pt-bt">
<head>
  <meta charset="utf-8"/>
  <link rel="shortcut icon" href="icon.jpg" />
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.5.0/css/font-awesome.min.css">
  <title>Ping Pong Breju</title>
  <style>

  canvas{
    position: absolute;
    left: 50%;
    top: 50%;
    background-image: url("fundo.png");
    margin-top: -300px;
    margin-left: -650px;
  }

  button{
    position: absolute;
    right: 1.5%;
    top: 88%;
    height: 70px;
    width: 90px;
    font-size: 30px;
    background-color: #E24040;
  }

  i{
    color: white;
  }

</style>
</head>

<body onload="tocarMusica()">

  <audio id="audio">
    <source src="musica.mp3" type="audio/mpeg">
  </audio>
  <audio id="errou">
    <source src="hohoho.wav" type="audio/wav">
  </audio>
  <canvas height="600" width="1300" id="mycanvas"></canvas>
  <button onClick=mostraPlacar()><i class="fa fa-fw fa-trophy"></i></button>
</body>
</html>
    
<script>
  
  var jogador1 = prompt("Informe o nome do jogador 1", "Jogador 1");
  var jogador2 = prompt("Informe o nome do jogador 2", "Jogador 2");

  if (jogador1 == null) {
    jogador1 = "Jogador 1";
  }
  if (jogador2 == null) {
    jogador2 = "Jogador 2";
  }

  var jogadas = 0;
  var canvas = document.getElementById("mycanvas");
  var contexto = canvas.getContext("2d");
  var teclas = {};

  var imgEsquerda = new Image();
  imgEsquerda.src = 'img1.png';

  var imgDireita = new Image();
  imgDireita.src = 'img2.png';

  var imgBola = new Image();
  imgBola.src = 'bola.png';

  var esquerda = {
    x: 15,
    y: canvas.height / 2 - 75,
    altura: 150,
    largura: 50,
    diry: 0,
    pontos: 0,
    velocidade: 5 //10
  };


  var direita = {
    x: canvas.width - 60,
    y: canvas.height / 2 - 75,
    altura: 150,
    largura: 50,
    diry: 0,
    pontos: 0,
    velocidade: 5 //10
  };

  var bola = {
    x: canvas.width / 2 - 25,
    y: canvas.height / 2 - 25,
    altura: 50,
    largura: 50,
    dirx: -1,
    diry: 1,
    mod: 0,
    velocidade: 1,
  };

  document.addEventListener("keydown", function(e){
    teclas[e.keyCode] = true;
  }, false);

  document.addEventListener("keyup", function(e) {
    delete teclas[e.keyCode]
  }, false);

  function raquetes(){
    if(87 in teclas && esquerda.y > 0)
      esquerda.y -= esquerda.velocidade;
    else if(83 in teclas && esquerda.y + esquerda.altura < canvas.height)
      esquerda.y += esquerda.velocidade;
    if(38 in teclas && direita.y > 0)
      direita.y -= direita.velocidade;
    else if(40 in teclas && direita.y + direita.altura < canvas.height)
      direita.y += direita.velocidade;
  };

    function mexeBola() {
      if(bola.y + bola.altura >= esquerda.y && bola.y <= esquerda.y + esquerda.altura && bola.x <= esquerda.x + esquerda.largura){
        bola.dirx = 1;
        bola.mod += 0.2;
        jogadas++;
      }
      else if(bola.y + bola.altura >= direita.y && bola.y <= direita.y + direita.altura && bola.x + bola.largura >= direita.x){
        bola.dirx = -1;
        bola.mod += 0.2;
        jogadas++;
      }

      if(bola.y <= 0){
        bola.diry = 1;
      }else if(bola.y + bola.altura >= canvas.height){
        bola.diry = -1;
      }

      bola.x += (bola.velocidade + bola.mod) * bola.dirx;
      bola.y += (bola.velocidade + bola.mod) * bola.diry;


      if(bola.x < esquerda.x + esquerda.largura - 10) {
        recomeca("2");
      } else if(bola.x + bola.largura > direita.x + 10){
        recomeca("1");
      }

    };

    function recomeca(ponto) {

      var max = sessionStorage.getItem(1);
      if(max == 0){
        sessionStorage[1] = jogadas;
      }else if (jogadas>max){
        sessionStorage[1] = jogadas;
      }

      jogadas = 0;
      tocarErro();
      if(ponto == "1")
        ++esquerda.pontos;
      else
        ++direita.pontos;

      esquerda.y = canvas.height / 2 - esquerda.altura / 2;
      direita.y = esquerda.y;
      bola.y = canvas.height / 2 - bola.altura / 2;
      bola.x = canvas.width /2 - bola.largura / 2;
      bola.mod = 0;
    };

    function tocarMusica(){
      var musica = document.getElementById("audio");
      musica.addEventListener('ended', function(){
        this.currentTime = 0; 
        this.play();
      }, false);
      musica.loop = true;
      musica.play();
    }

    function tocarErro(){
      var musica = document.getElementById("errou");
      musica.play();
    }

    function mostraPlacar() {
      var max = sessionStorage.getItem(1);
      var texto = '\n\n';

      for (var i = 1; i < sessionStorage.length; i++) {
        var key = sessionStorage.key(i);
        texto = texto.concat(sessionStorage.getItem(key) + '\n');
      }

      if(max != null){
	    alert("Jogadas maximas: "+max+texto);
	  }else {
	    alert("Jogadas maximas: 0");
	  }
    }


    function exibeJogo() {
      if((esquerda.pontos == 5) ||( direita.pontos == 5)){
        if(esquerda.pontos == 5){
          var i = sessionStorage.length + 1;
          sessionStorage[i]=jogador1+':'+esquerda.pontos+'  vs  '+jogador2+':'+direita.pontos;
          alert(jogador1 +' ganhou!');
        }else{
          alert(jogador2 +' ganhou!');
          var i = sessionStorage.length + 1;
          sessionStorage[i]=jogador2+':'+direita.pontos+'  vs  '+jogador1+':'+esquerda.pontos;
        }

        if(confirm("Deseja jogar novamente?")){
          esquerda.pontos = 0;
          direita.pontos = 0;
          jogadas = 0;

        }else{
          esquerda.pontos = 0;
          direita.pontos = 0;
          jogador1 = prompt("Informe o nome do jogador 1", "Jogador 1");
          jogador2 = prompt("Informe o nome do jogador 2", "Jogador 2");

          if (jogador1 == null) {
            jogador1 = "Jogador 1";
          }
          if (jogador2 == null) {
            jogador2 = "Jogador 2";
          }
        }
      }

      raquetes();
      mexeBola();
      contexto.clearRect(0, 0, canvas.width, canvas.height);

      contexto.fillStyle = "#c4321f";
      contexto.drawImage(imgBola, bola.x, bola.y, bola.largura, bola.altura);

      contexto.drawImage(imgEsquerda,esquerda.x, esquerda.y, esquerda.largura, esquerda.altura);
      contexto.drawImage(imgDireita, direita.x, direita.y, direita.largura, direita.altura);

      contexto.font = "35px Arial Bold";
      contexto.fillText(jogador1+" : " + esquerda.pontos, 25, 50);
      contexto.fillText(jogador2+ ": " + direita.pontos, canvas.width - 230, 50);
      contexto.fillText('Jogadas Máx: '+ jogadas,500, 50);
    };

    setInterval(exibeJogo, 5);
</script>